var nbSeconds;
var masterMove = true;
var persoGrid = new Array();
var colorGrid = new Array();
var lifeGrid = new Array();
var digGrid = new Array();
var countGrid = new Array();
var colorCounts = new Array();
var colorTotal = new Array();
var colorMaster = new Array();
var heightGauges;
var malusBlue;
var masterX;
var masterY;
var bonusDig;
var gameTimer;
var boost;
var low;

var mute = false;

var tutoPut = false;
var tutoMalus = false;
var tutoOver = false;
var step = 0;
var tutoSteps = new Array(
new Array("This is you, the <strong>Guide</strong>. You are here to <strong>dig</strong> the resources of this piece of rock.", 0, 40),
new Array("To <strong>second</strong> you, here are <strong>10</strong> workers. (So basically '10 seconds'...)", 170, 40),
new Array("There are 3 types of resources to collect:<ul><li><strong>Red</strong>: to score</li><li><strong>Blue</strong>: to survive</li><li><strong>Yellow</strong>: to speed</li></ul>", 575, 120),
new Array("Controls are simple:<ul><li>Click to put a man</li><li>Click again to remove him.</li></ul>(Try to put the Guide and some workers)", 575, 120),
new Array("A man (Guide or second) automatically digs resources in the four directions (but not below him)<br/><img src='images/tuto5.png' />", 575, 120),
new Array("You can dig the same square with <strong>several men</strong> to improve the production.<br/><img src='images/tuto6.png' />", 575, 120),
new Array("A square with a man above can't be dug. The resources <strong>disappear</strong> after a while.", 575, 120),
new Array("If there is no available resources in the four directions, a man <strong>jumps</strong> to find a new resource below him. (Try!)<br/><img src='images/tuto8.png' />", 575, 120),
new Array("He jumps even if there is a resource below him, to try to find another.", 575, 120),
new Array("The <strong>Guide</strong> is very important: he collects and jumps faster!<br/><img src='images/tuto10.png' />", 575, 120),
new Array("Most importantly, If the Guide digs only <strong>one color</strong> of resource, you get <strong>+50%</strong> for all the production of this color!<br/><img src='images/tuto11.png' />", 575, 120),
new Array("Lastly, an overview on the 3 resources.", 330, 160),
new Array("The <strong>blue</strong> is oxygen. If you empty the gauge, the <strong>game is over</strong>. The more you have men working more you consume blue.", 330, 160),
new Array("The <strong>yellow</strong> is energy. If you fill the gauge ut to 90%, you get a <strong>big bonus</strong> to dig and jump! Yellow is consume over time.", 330, 160),
new Array("The <strong>red</strong> is precious. You are here to <strong>collect all you can</strong>.<br/><br/>The asteroid will be reset... Good luck!", 330, 160));

var sounds = new SFX('sfx');

sounds.add({
	gameOver: [ 'gameOver', 100 ],
	highYellow:  [ 'highYellow', 100 ],
	lowBlue: [ 'lowBlue', 100 ],
	put: [ 'put', 100, 20],
	remove:  [ 'remove', 100, 20],
	music:  [ 'music', 35]
});

$(document).ready(function(){
	
	sounds.loop("music");
	
	$("#over").hide();
	$("#content").hide();
	$("#mOver").hide();
	$("#mBonus").hide();
	$("#tip").hide();
	$("#skip").hide();
	
	init();
	
	$("#sounds").click(function(){
		sounds.mute(!mute);
		mute = !mute;
		if(!mute)
			sounds.loop("music");
	});
	
   	$("#title").click(function(){
   		$("#content").show();
   		$("#title").fadeOut()
   		$("#tip").delay("600").fadeIn("slow");
   		$("#skip").delay("1000").fadeIn("slow");
   	});
	
	//Tuto
	$("#tip").click(function(){
		
		sounds.play("remove");
		
		if(step < tutoSteps.length)
		{
			$("#tip").css("marginLeft", tutoSteps[step][1]).css("marginTop", tutoSteps[step][2]).html(tutoSteps[step][0]);				
			
			step++;
			
			switch(step)
			{
				case 3 :	
					initMap();
					break;
				case 4 :
					tutoPut = true;
					break;	
				case 12 :
					tutoMalus = true;
					break;
				case 13 :
					$("#mOver").fadeIn();
					break;
				case 14 :
					$("#mBonus").fadeIn();
					break;
			}
		}else{
			//Reset
			tutoOver = true;
			$("#tip").hide();
			$("#skip").hide();
			clearInterval(gameTimer);
			
			init();
			initMap();	
		}
	});
		
	$("#skip").click(function(){
   		
   		tutoPut = true;
   		tutoMalus = true;
   		$("#mOver").fadeIn();
   		$("#mBonus").fadeIn();
   		
   		//Reset
		tutoOver = true;
		$("#tip").hide();
		$("#skip").hide();
		clearInterval(gameTimer);
		
		init();
		initMap();
   	});

});

function init(){
	
	//Variables
	nbSeconds = 10;
	masterMove = true;
	persoGrid = new Array();
	colorGrid = new Array();
	lifeGrid = new Array();
	digGrid = new Array();
	countGrid = new Array();
	colorCounts = new Array();
	colorTotal = new Array();
	colorMaster = new Array();
	heightGauges = 350;
	malusBlue = 1;
	masterX = 0;
	masterY = 0;
	bonusDig = 0;
	gameTimer;
	boost = false;
	low = false;
	
	colorCounts[1] = 0;
	colorCounts[2] = 9;
	colorCounts[3] = 0;
	
	colorTotal[1] = 0;
	colorTotal[2] = 50;
	colorTotal[3] = 25;
	
	colorMaster[1] = false;
	colorMaster[2] = false;
	colorMaster[3] = false;
	
	$("#astero").html("");
	
	//Génération de la grille
	for(var i=0 ; i < 8 ; i++)
	{
		persoGrid[i] = new Array();
		colorGrid[i] = new Array();
		lifeGrid[i] = new Array();
		digGrid[i] = new Array();
		countGrid[i] = new Array();
		
		for(var j=0 ; j < 8 ; j++)
		{
			$("#astero").append('<div class="case" id="c-'+j+'-'+i+'"></div>');
			persoGrid[i][j] = 0;
			colorGrid[i][j] = 0;
			lifeGrid[i][j] = -1;
			digGrid[i][j] = -1;
			countGrid[i][j] = 0;
			
			/*
			if(i == 2 && j == 2)
			{
				persoGrid[2][2] = 2;
				$("#c-"+j+"-"+i).html('<div class="master"></div>');
			}
			*/
		}
	}
	
	updateRes();	
}

function initMap(){
	
	//Premières couleurs
	randomColors("red", 3, 1)
	randomColors("blue", 6, 2)
	randomColors("yellow", 5, 3)
	updateCount();
	
	updateRes();
	
	interval();
	gameTimer = setInterval("interval()", 1000);
	
	$(".case").click(function(){
		if(tutoPut)
		{
			var coo = $(this).attr("id").split("-");
			var x = coo[1];
			var y = coo[2];
				
			if(persoGrid[x][y] == 0)
			{
				if(masterMove)
				{
					persoGrid[x][y] = 2;
					masterX = x;
					masterY = y;
	
					$(this).html('<div class="master"></div>');
					masterMove = false;
				}else{	
					if(nbSeconds > 0)
					{
						persoGrid[x][y] = 1;
						$(this).html('<div class="second"></div>');
						nbSeconds--;
					}
				}
				sounds.play("put", true);
			}else{
				if(persoGrid[x][y] == 1)
				{
					nbSeconds++;
				}else{
					masterMove = true;
				}
				
				persoGrid[x][y] = 0;
				$(this).html('');
				sounds.play("remove", true);
			}
			
			updateRes();
			updateCount();
		}
	});
}

function interval() {
	//Dimunition ressource
	
	for(var i=0 ; i < 8 ; i++)
	{
		for(var j=0 ; j < 8 ; j++)
		{
			if(countGrid[j][i] > 0)
			{
				if(lifeGrid[j][i] > -1)
				{
					lifeGrid[j][i]--;
					if(lifeGrid[j][i] == 0)
					{
						lifeGrid[j][i] = -1;
						colorGrid[j][i] = 0;
						countGrid[j][i] = 0;
						$("#c-"+j+"-"+i).removeClass();
						$("#c-"+j+"-"+i).addClass("case");
						$("#c-"+j+"-"+i).html("");	
					}
				}
			}
		}
	}
	
	//Dig
	for(var i=0 ; i < 8 ; i++)
	{
		for(var j=0 ; j < 8 ; j++)
		{
			if(persoGrid[j][i] != 0)
			{
				var count = 0;
				
				if(j > 0)
				{
					if(persoGrid[j-1][i] == 0)
						count += colorGrid[j-1][i];
				}
					
				if(i > 0)
				{
					if(persoGrid[j][i-1] == 0)
						count += colorGrid[j][i-1];	
				}
					
				if(j < 7)
				{
					if(persoGrid[j+1][i] == 0)
						count += colorGrid[j+1][i];
				}
					
				if(i < 7)
				{
					if(persoGrid[j][i+1] == 0)
						count += colorGrid[j][i+1];
				}
					
				if(count == 0)
				{
					if(digGrid[j][i] > 0)
					{
						digGrid[j][i]--;
						if (boost)
							digGrid[j][i]--;
						
						if(digGrid[j][i] <= 0)
						{
							//new color
							digGrid[j][i] = -1;	
							
							var alea = Math.floor((Math.random()*(100+bonusDig)));
							var color = "blue";
							var code = 2;
							
							if(alea > 80 + (bonusDig / 3))
							{
								color = "red";
								code = 1;	
							}else if(alea > 45)
							{
								color = "yellow";
								code = 3;	
							}
							
							addColor(j, i, color, code);
						}
						
						$("#c-"+j+"-"+i+" .second").animate({marginTop:"-20px"}, 200).animate({marginTop:"-10px"}, 200);
						$("#c-"+j+"-"+i+" .master").animate({marginTop:"-28px"}, 200).animate({marginTop:"-20px"}, 200);
						
					}else{	
						digGrid[j][i] = 6 + Math.floor((Math.random()*5));
					}	
				}
			}
		}
	}
	
	updateCount();
	
	colorTotal[1] += colorCounts[1];
	colorTotal[2] += colorCounts[2]/10;
	colorTotal[3] += colorCounts[3]/10;
	
	malusBlue += 0.005;
	bonusDig += 0.5;
	
	//Red
	$("#red_count #score").html(Math.floor(colorTotal[1]));
	
	//Borne
	if(colorTotal[2] < 1)
	{
		if(tutoOver)
		{	
			//game over ===========
			clearInterval(gameTimer);
			$("#finalScore span").html(Math.floor(colorTotal[1]));
			$("#scoreV").val(Math.floor(colorTotal[1]));
			
			$("#over").fadeIn();
			$("#content").fadeOut();
			sounds.play("gameOver");
			
			$("#formS").submit(function() {		
		        var pseudo = $('#pseudoV').val();
		 
		        if(pseudo == "")
		        {
		            alert("Please give a name!");
		        }
		        else
		        {
		            $.ajax({
		                url: $(this).attr("action"), 
		                type: $(this).attr("method"),
		                data: $(this).serialize(),
		                success: function(html) {
		                    $("#divForm").html(html);
		                    $("#over").click(function(){
					   			location.reload();
					   		});
		                }
		            });
		        }
		        return false; 
		    });
		}
		
	}else if(colorTotal[2] > 100)
	{
		colorTotal[2] = 100;	
	}
	
	if(colorTotal[3] < 0)
	{
		colorTotal[3] = 0;
	}else if(colorTotal[3] > 100)
	{
		colorTotal[3] = 100;	
	}
	
	//Jauges
	
	var pBlue = heightGauges - (colorTotal[2] * heightGauges / 100)
	$("#blue_gauge").css("backgroundPosition", "0 "+pBlue+"px");
	
	var pYellow = heightGauges - (colorTotal[3] * heightGauges / 100)
	$("#yellow_gauge").css("backgroundPosition", "0 "+pYellow+"px");
}

function updateRes()
{
	$("#reserve").html("");
	
	if(masterMove)
	{
		$("#reserve").append('<div class="master masS">');
	}
	
	for(var i=0 ; i < nbSeconds ; i++)
	{
		$("#reserve").append('</div><div class="second resS">');
	}
}

function randomColors(color, nb, code)
{
	for(var i=0 ; i < nb ; i++)
	{
		x = Math.floor((Math.random()*8)); 
		y = Math.floor((Math.random()*8));
		
		if(colorGrid[x][y] == 0)
		{
			addColor(x, y, color, code);
		}else{
			i--;
		}
	}
}

function addColor(x, y, color, code)
{
	colorGrid[x][y] = code;
	lifeGrid[x][y] = 10 + Math.floor((Math.random()*10));
	$("#c-"+x+"-"+y).removeClass();
	$("#c-"+x+"-"+y).addClass("case "+color);
}

function updateCount()
{
	colorCounts[1] = 0;
	colorCounts[2] = 0;
	colorCounts[3] = 0;
	
	for(var i=0 ; i < 8 ; i++)
	{
		for(var j=0 ; j < 8 ; j++)
		{
			if(colorGrid[j][i] != 0)
			{
				if(persoGrid[j][i] == 0)
				{
					var count = 0;
					
					if(j > 0)
						count += persoGrid[j-1][i];
						
					if(i > 0)
						count += persoGrid[j][i-1];	
						
					if(j < 7)
						count += persoGrid[j+1][i];
						
					if(i < 7)
						count += persoGrid[j][i+1];	
						
					count *= count;
					countGrid[j][i] = count;
					colorCounts[colorGrid[j][i]] += count;
						
					$("#c-"+j+"-"+i).html('<div class="nb">'+count+'</div>');
				}else{
					countGrid[j][i] = 0;
				}
			}
		}
	}
	
	colorMaster[1] = false;
	colorMaster[2] = false;
	colorMaster[3] = false;
	
	if(!masterMove)
	{
		var tests = new Array();
		var j = parseInt(masterX);
		var i = parseInt(masterY);
		
		
		
		if(j > 0)
		{
			if(colorGrid[j-1][i] != 0 && persoGrid[j-1][i] == 0)	
				tests.push(colorGrid[j-1][i]);
		}
			
		if(i > 0)
		{
			if(colorGrid[j][i-1] != 0 && persoGrid[j][i-1] == 0)
				tests.push(colorGrid[j][i-1]);	
		}
			
		if(j < 7)
		{
			if(colorGrid[j+1][i] != 0 && persoGrid[j+1][i] == 0)	
				tests.push(colorGrid[j+1][i]);
		}
			
		if(i < 7)
		{
			if(colorGrid[j][i+1] != 0 && persoGrid[j][i+1] == 0)	
				tests.push(colorGrid[j][i+1]);
		}		
		
		if(tests.length > 0)
		{
			var first = tests[0];
			
			var ok = true;
			for(var i = 0 ; i < tests.length ; i++)
			{
				if(tests[i] != first)
					ok = false;
			}	
			
			if(ok)
			{
				if(first == 1)
					$(".master").html('<img src="images/red_head.png" />');
					
				if(first == 2)
					$(".master").html('<img src="images/blue_head.png" />');
					
				if(first == 3)
					$(".master").html('<img src="images/yellow_head.png" />');
					
				colorCounts[first] += Math.floor(colorCounts[first] / 2);
				colorMaster[first] = true;
				
			}else{
				$(".master").html("");
			}
			
		}else{
			$(".master").html("");	
		}
	}
	
	//Malus
	if(tutoMalus)
	{
		colorCounts[2] -= Math.ceil((((10 - nbSeconds) + (!masterMove * 4)) * malusBlue) + 1);
		colorCounts[3] -= Math.ceil(colorTotal[3] / 20);
	}
	
	//Bonus
	
	$("#yellow_gauge").removeClass();
	$("#yellow_gauge").addClass("gauge");
	
	if(colorTotal[3] > 90)
	{
		if(!boost)
			sounds.play("highYellow");
			
		boost = true;
		$("#yellow_gauge").addClass("bonus");
		
		colorCounts[1] += colorCounts[1] / 2;
		colorCounts[2] += colorCounts[2] / 2;
		colorCounts[3] += colorCounts[3] / 2;
		
	}else{
		
		boost = false;
	}
	
	//low
	if(colorTotal[2] < 10)
	{
		if(!low)
			sounds.play("lowBlue");
			
		low = true;	
	}else{
		low = false;
	}
	
	updateCounters();
}

function updateCounters()
{
	Math.round(colorCounts[1]) >= 0 ? $("#nbRed").html("+"+Math.round(colorCounts[1])) : $("#nbRed").html(Math.round(colorCounts[1]));
	
	Math.round(colorCounts[2]) >= 0 ? $("#nbBlue").html("+"+Math.round(colorCounts[2])) : $("#nbBlue").html(Math.round(colorCounts[2]));
	
	Math.round(colorCounts[3]) >= 0 ? $("#nbYellow").html("+"+Math.round(colorCounts[3])) : $("#nbYellow").html(Math.round(colorCounts[3]));
	
	if(colorMaster[1]) $("#nbRed").append('<span class="prime"> (+50%)</span>');
	if(colorMaster[2]) $("#nbBlue").append('<br/><span class="prime">(+50%)</span>');
	if(colorMaster[3]) $("#nbYellow").append('<br/><span class="prime">(+50%)</span>');
}

function changeTip(x, y, html)
{
	$("#tip").css("marginLeft", x).css("marginTop", y).html(html);	
}


